package de.fraunhofer.iem.dataprovider.occmd.entity

import jakarta.persistence.*
import org.hibernate.Hibernate
import java.util.*

@Entity
@Table(name = "occmdsecret")
class OccmdSecretEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name = "id", nullable = false)
    var id: UUID? = null

    @Column(name = "score")
    var score: Double? = null

    @ElementCollection(targetClass = String::class, fetch = FetchType.EAGER)
    @CollectionTable(name = "occmdsecret_results", joinColumns = [JoinColumn(name = "occmdsecret_id")])
    @Column(name = "results", length = 512, nullable = false)
    var results: MutableList<String> = mutableListOf()

    override fun equals(other: Any?): Boolean {
        if (this === other) return true
        if (other == null || Hibernate.getClass(this) != Hibernate.getClass(other)) return false
        other as OccmdSecretEntity

        return id != null && id == other.id
    }

    override fun hashCode(): Int = javaClass.hashCode()
}