package de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.ort

import de.fraunhofer.iem.dataprovider.repository.service.RepositoryService
import de.fraunhofer.iem.dataprovider.taskManager.events.Event
import de.fraunhofer.iem.dataprovider.taskManager.tasks.Task
import de.fraunhofer.iem.dataprovider.taskManager.tasks.tools.ort.json.OrtJson
import de.fraunhofer.iem.dataprovider.tool.service.ToolService
import io.ktor.client.*
import io.ktor.client.call.*
import io.ktor.client.engine.cio.*
import io.ktor.client.plugins.contentnegotiation.*
import io.ktor.client.request.*
import io.ktor.client.statement.*
import io.ktor.serialization.kotlinx.json.*
import kotlinx.serialization.json.Json
import java.util.*

class OrtApiTask(
    override val responseChannel: suspend (event: Event) -> Unit,
    val repoId: UUID,
    private val toolService: ToolService,
    private val repositoryService: RepositoryService
) : Task() {

    override suspend fun execute() {

        val client = HttpClient(CIO) {
            install(ContentNegotiation) {
                json(
                    Json { ignoreUnknownKeys = true }
                )
            }
        }

        val response: HttpResponse = client.get("http://localhost:3000/ort")
        val ortJson = response.body<OrtJson>()
        println(response.status)
        println(ortJson)
        client.close()
//        val ortDto = ortJsonToDto(ortJson)
//        val dependencies = mutableListOf<DependencyDto>()
//
//        ortDto.packages.forEach { p ->
//            if (p.nameAndVersion != null) {
//                dependencies.add(DependencyDto(name = p.nameAndVersion))
//            }
//        }
//
//        ortDto.advisorResults.forEach { advisorResult ->
//
//            var dependency = dependencies.find { it.name == advisorResult.identifier }
//
//            if (dependency == null) {
//                dependency = DependencyDto(advisorResult.identifier)
//                dependencies.add(dependency)
//            }
//            advisorResult.vulnerabilities.forEach { vulnerability ->
//                if (vulnerability.id != null) {
//
//                    val vulnerabilityScoreDtos =
//                        vulnerability.references.mapNotNull { ref ->
//                            if (ref.severity != null && ref.scoringSystem != null) {
//                                val scoringSystem = VulnerabilityScoringSystemEnum.fromString(ref.scoringSystem)
//                                scoringSystem?.let {
//                                    return@mapNotNull VulnerabilityScoreDto(severity = ref.severity, it)
//                                }
//                            }
//                            return@mapNotNull null
//                        }
//                    val vulnerabilityDto =
//                        VulnerabilityDto(vulnerability.id, vulnerabilityScoreDtos.toMutableList())
//                    dependency.vulnerabilities.add(vulnerabilityDto)
//                }
//            }
//        }

    }

}
